/// @cond EO_CXX_EO_IMPL

inline void elm::calendar::selected_time_set(Elm_Calendar_Time * selected_time_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_selected_time_set(selected_time_));
}

inline bool elm::calendar::selected_time_get(Elm_Calendar_Time* selected_time_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_selected_time_get(selected_time_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Calendar_Mark * elm::calendar::mark_add(::efl::eina::string_view mark_type_, Elm_Calendar_Time * mark_time_, Elm_Calendar_Mark_Repeat_Type repeat_) const
{
   Elm_Calendar_Mark * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_mark_add(::efl::eolian::to_c(mark_type_), mark_time_, repeat_));
   return _tmp_ret;
}

inline void elm::calendar::marks_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_marks_clear());
}

inline void elm::calendar::marks_draw() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_marks_draw());
}

inline bool elm::calendar::displayed_time_get(Elm_Calendar_Time* displayed_time_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_displayed_time_get(displayed_time_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Calendar_Weekday elm::calendar::first_day_of_week_get() const
{
   Elm_Calendar_Weekday _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_first_day_of_week_get());
   return _tmp_ret;
}

inline void elm::calendar::first_day_of_week_set(Elm_Calendar_Weekday day_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_first_day_of_week_set(day_));
}

inline Elm_Calendar_Selectable elm::calendar::selectable_get() const
{
   Elm_Calendar_Selectable _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_selectable_get());
   return _tmp_ret;
}

inline void elm::calendar::selectable_set(Elm_Calendar_Selectable selectable_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_selectable_set(selectable_));
}

inline double elm::calendar::interval_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_interval_get());
   return _tmp_ret;
}

inline void elm::calendar::interval_set(double interval_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_interval_set(interval_));
}

inline const char ** elm::calendar::weekdays_names_get() const
{
   const char ** _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_weekdays_names_get());
   return _tmp_ret;
}

inline void elm::calendar::weekdays_names_set(const char ** weekdays_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_weekdays_names_set(weekdays_));
}

inline Elm_Calendar_Select_Mode elm::calendar::select_mode_get() const
{
   Elm_Calendar_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_select_mode_get());
   return _tmp_ret;
}

inline void elm::calendar::select_mode_set(Elm_Calendar_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_select_mode_set(mode_));
}

inline void elm::calendar::min_max_year_get(int* min_, int* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_min_max_year_get(min_, max_));
}

inline void elm::calendar::min_max_year_set(int min_, int max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_min_max_year_set(min_, max_));
}

inline void elm::calendar::format_function_set(Elm_Calendar_Format_Cb format_function_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_format_function_set(format_function_));
}

inline ::efl::eina::crange_list< Elm_Calendar_Mark * > elm::calendar::marks_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_marks_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Calendar_Mark * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline void eo_cxx::elm::calendar::selected_time_set(Elm_Calendar_Time * selected_time_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_selected_time_set(selected_time_));
}

inline bool eo_cxx::elm::calendar::selected_time_get(Elm_Calendar_Time* selected_time_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_selected_time_get(selected_time_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Calendar_Mark * eo_cxx::elm::calendar::mark_add(::efl::eina::string_view mark_type_, Elm_Calendar_Time * mark_time_, Elm_Calendar_Mark_Repeat_Type repeat_) const
{
   Elm_Calendar_Mark * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_mark_add(::efl::eolian::to_c(mark_type_), mark_time_, repeat_));
   return _tmp_ret;
}

inline void eo_cxx::elm::calendar::marks_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_marks_clear());
}

inline void eo_cxx::elm::calendar::marks_draw() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_marks_draw());
}

inline bool eo_cxx::elm::calendar::displayed_time_get(Elm_Calendar_Time* displayed_time_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_displayed_time_get(displayed_time_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Calendar_Weekday eo_cxx::elm::calendar::first_day_of_week_get() const
{
   Elm_Calendar_Weekday _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_first_day_of_week_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::calendar::first_day_of_week_set(Elm_Calendar_Weekday day_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_first_day_of_week_set(day_));
}

inline Elm_Calendar_Selectable eo_cxx::elm::calendar::selectable_get() const
{
   Elm_Calendar_Selectable _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_selectable_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::calendar::selectable_set(Elm_Calendar_Selectable selectable_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_selectable_set(selectable_));
}

inline double eo_cxx::elm::calendar::interval_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_interval_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::calendar::interval_set(double interval_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_interval_set(interval_));
}

inline const char ** eo_cxx::elm::calendar::weekdays_names_get() const
{
   const char ** _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_weekdays_names_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::calendar::weekdays_names_set(const char ** weekdays_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_weekdays_names_set(weekdays_));
}

inline Elm_Calendar_Select_Mode eo_cxx::elm::calendar::select_mode_get() const
{
   Elm_Calendar_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_select_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::calendar::select_mode_set(Elm_Calendar_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_select_mode_set(mode_));
}

inline void eo_cxx::elm::calendar::min_max_year_get(int* min_, int* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_min_max_year_get(min_, max_));
}

inline void eo_cxx::elm::calendar::min_max_year_set(int min_, int max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_min_max_year_set(min_, max_));
}

inline void eo_cxx::elm::calendar::format_function_set(Elm_Calendar_Format_Cb format_function_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_calendar_format_function_set(format_function_));
}

inline ::efl::eina::crange_list< Elm_Calendar_Mark * > eo_cxx::elm::calendar::marks_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_calendar_marks_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Calendar_Mark * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::eo_cxx::elm::calendar::operator ::elm::calendar() const
{
   return *static_cast<::elm::calendar const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::calendar::operator ::elm::calendar&()
{
   return *static_cast<::elm::calendar*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::calendar::operator ::elm::calendar const&() const
{
   return *static_cast<::elm::calendar const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_calendar_selected_time_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Calendar_Time * selected_time_)
{
   try
      {
         static_cast<T*>(self->this_)->selected_time_set(selected_time_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_calendar_selected_time_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Calendar_Time* selected_time_)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_time_get(selected_time_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
Elm_Calendar_Mark * elm_calendar_mark_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * mark_type_, Elm_Calendar_Time * mark_time_, Elm_Calendar_Mark_Repeat_Type repeat_)
{
   try
      {
         return static_cast<T*>(self->this_)->mark_add(::efl::eolian::to_cxx<::efl::eina::string_view>(mark_type_, std::tuple<std::false_type>()), mark_time_, repeat_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Calendar_Mark * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_calendar_marks_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->marks_clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_calendar_marks_draw_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->marks_draw();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_calendar_displayed_time_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Calendar_Time* displayed_time_)
{
   try
      {
         return static_cast<T*>(self->this_)->displayed_time_get(displayed_time_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
Elm_Calendar_Weekday elm_calendar_first_day_of_week_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->first_day_of_week_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Calendar_Weekday _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_calendar_first_day_of_week_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Calendar_Weekday day_)
{
   try
      {
         static_cast<T*>(self->this_)->first_day_of_week_set(day_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Calendar_Selectable elm_calendar_selectable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selectable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Calendar_Selectable _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_calendar_selectable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Calendar_Selectable selectable_)
{
   try
      {
         static_cast<T*>(self->this_)->selectable_set(selectable_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_calendar_interval_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->interval_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_calendar_interval_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double interval_)
{
   try
      {
         static_cast<T*>(self->this_)->interval_set(interval_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
const char ** elm_calendar_weekdays_names_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->weekdays_names_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char ** _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_calendar_weekdays_names_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char ** weekdays_)
{
   try
      {
         static_cast<T*>(self->this_)->weekdays_names_set(weekdays_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Calendar_Select_Mode elm_calendar_select_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->select_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Calendar_Select_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_calendar_select_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Calendar_Select_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->select_mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_calendar_min_max_year_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* min_, int* max_)
{
   try
      {
         static_cast<T*>(self->this_)->min_max_year_get(min_, max_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_calendar_min_max_year_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int min_, int max_)
{
   try
      {
         static_cast<T*>(self->this_)->min_max_year_set(min_, max_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_calendar_format_function_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Calendar_Format_Cb format_function_)
{
   try
      {
         static_cast<T*>(self->this_)->format_function_set(format_function_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::crange_list< Elm_Calendar_Mark * > elm_calendar_marks_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->marks_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Calendar_Mark * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::calendar >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual void selected_time_set(Elm_Calendar_Time * selected_time_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_selected_time_set(selected_time_));
      }

      virtual bool selected_time_get(Elm_Calendar_Time* selected_time_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_selected_time_get(selected_time_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Elm_Calendar_Mark * mark_add(::efl::eina::string_view mark_type_, Elm_Calendar_Time * mark_time_, Elm_Calendar_Mark_Repeat_Type repeat_)
      {
         Elm_Calendar_Mark * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_mark_add(::efl::eolian::to_c(mark_type_), mark_time_, repeat_));
            return _tmp_ret;
      }

      virtual void marks_clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_marks_clear());
      }

      virtual void marks_draw()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_marks_draw());
      }

      virtual bool displayed_time_get(Elm_Calendar_Time* displayed_time_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_displayed_time_get(displayed_time_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Elm_Calendar_Weekday first_day_of_week_get()
      {
         Elm_Calendar_Weekday _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_first_day_of_week_get());
            return _tmp_ret;
      }

      virtual void first_day_of_week_set(Elm_Calendar_Weekday day_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_first_day_of_week_set(day_));
      }

      virtual Elm_Calendar_Selectable selectable_get()
      {
         Elm_Calendar_Selectable _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_selectable_get());
            return _tmp_ret;
      }

      virtual void selectable_set(Elm_Calendar_Selectable selectable_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_selectable_set(selectable_));
      }

      virtual double interval_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_interval_get());
            return _tmp_ret;
      }

      virtual void interval_set(double interval_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_interval_set(interval_));
      }

      virtual const char ** weekdays_names_get()
      {
         const char ** _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_weekdays_names_get());
            return _tmp_ret;
      }

      virtual void weekdays_names_set(const char ** weekdays_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_weekdays_names_set(weekdays_));
      }

      virtual Elm_Calendar_Select_Mode select_mode_get()
      {
         Elm_Calendar_Select_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_select_mode_get());
            return _tmp_ret;
      }

      virtual void select_mode_set(Elm_Calendar_Select_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_select_mode_set(mode_));
      }

      virtual void min_max_year_get(int* min_, int* max_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_min_max_year_get(min_, max_));
      }

      virtual void min_max_year_set(int min_, int max_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_min_max_year_set(min_, max_));
      }

      virtual void format_function_set(Elm_Calendar_Format_Cb format_function_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_calendar_format_function_set(format_function_));
      }

      virtual ::efl::eina::crange_list< Elm_Calendar_Mark * > marks_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_calendar_marks_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Calendar_Mark * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::calendar >
{
   static constexpr int value = 
#if defined(CALENDAR_PROTECTED) && defined(CALENDAR_BETA)
      20
#elif defined(CALENDAR_PROTECTED)
      20
#elif defined(CALENDAR_BETA)
      20
#else
      20
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::calendar>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_selected_time_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_selected_time_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_selected_time_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_selected_time_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_mark_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_mark_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_marks_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_marks_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_marks_draw_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_marks_draw);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_displayed_time_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_displayed_time_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_first_day_of_week_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_first_day_of_week_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_first_day_of_week_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_first_day_of_week_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_selectable_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_selectable_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_selectable_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_selectable_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_interval_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_interval_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_interval_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_interval_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_weekdays_names_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_weekdays_names_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_weekdays_names_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_weekdays_names_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_select_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_select_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_select_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_select_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_min_max_year_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_min_max_year_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_min_max_year_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_min_max_year_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_format_function_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_format_function_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_calendar_marks_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_calendar_marks_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::calendar >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::calendar >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::calendar>)
{
   return (ELM_CALENDAR_CLASS);
}

} } }

/// @endcond

